import HuffmanTree, { Comparable } from "./HuffmanTree";
export default class HuffmanCoding<T extends Comparable<T>> {
    private _hufftree;
    readonly hufftree: HuffmanTree<T>;
    private _encodedString;
    readonly encodedString: string;
    originalInput: T[];
    input: T[];
    compressionRatio(inputSize: number): number;
    private constructor();
    static fromTree<K extends Comparable<K>>(tree: HuffmanTree<K>): HuffmanCoding<K>;
    static fromPlainText(plaintext: string): HuffmanCoding<string>;
    encode(message?: T[]): string;
    decode(encoded: string): T[];
}
