export interface Comparable<T> {
    localeCompare: (x: T) => number;
}
export default class HuffmanTree<T extends Comparable<T>> {
    message: T[];
    _frequencies: Map<T, number>;
    _tree: Tree<T> | undefined;
    readonly tree: Tree<T>;
    _keyLengths: Map<T, number> | undefined;
    readonly keyLengths: Map<T, number>;
    _huffmanCodes: Map<T, string> | undefined;
    readonly huffmanCodes: Map<T, string>;
    constructor(message: T[]);
    private mkTree;
    private toKeyLengths;
    private toHuffmanCodes;
}
interface Tree<T> {
    count: number;
    literal?: T;
    leftTree?: Tree<T>;
    rightTree?: Tree<T>;
}
export {};
